Foreman - Refactor #13409

Remove maintain_test_schema! Rails initializer
01/27/2016 09:49 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Rails

Target version: 1.11.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/3182
Description

The config/initializers/0_maintain_test_schema.rb initializer added in #7230 can potentially be removed with some further fixes.

It exists to initialise the test database before the main Rails app and models are initialised, fixing a couple of bugs where loading the
model requires the table to already be available. If the table isn't available then validators etc. aren't set up correctly and tests may
fail. Removing the initialiser and the test DB, then running rake test shows the issue. More info in #12873.

#13039 fixed one issue, but | think two further fixes are required:

1) validates_lengths_from_database needs to avoid reading DB information to set up its validators.
https://github.com/rubiety/validates_lengths_from_database/pull/12 fixes this.

2) Our own validate_inclusion_in_families validator should not check for the attribute's existence - this check can probably be

removed.

Related issues:
Related to Foreman - Feature #7230: Upgrade Ruby on Rails to 4.1

Related to Foreman - Refactor #13039: Remove DB queries from class of Unatten...

Related to Foreman - Feature #12873: Update Rails to 4.1.latest

Blocked by Foreman - Bug #13574: Plugins with Setting subclasses raise super:...

Closed 08/22/2014
Closed 01/07/2016
Closed 12/18/2015
Closed 02/05/2016

Associated revisions

Revision f20c2a1a - 02/15/2016 07:22 AM - Dominic Cleal

fixes #13409 - remove early initialisation of test DB

All models etc. referenced within the Rails environment startup,
including in initialisers should load without making any reference to
the database. This ensures when running “rake test” without a test DB
set up already that the Rails env can be loaded first by Rails before

it prepares the test DB from db/schema.rb (itself created by a
db:migrate in dev/prod envs).

The table_name for Ptable needed to be overridden, matching
ProvisioningTemplate as it defaulted to 'ptables’ rather than
‘templates' when the “attribute_names’ call was removed from
validate_inclusion_in_families.

References to attribute_names in API controller wrapping overrides

were replaced by reusing the protected_attribute lists, which don't use
the database and are also more consistent than the existing lists.

Revision 56b90b51 - 02/16/2016 08:04 AM - Dominic Cleal

refs #13409 - min version of validates_lengths_from_database
https://projects.theforeman.org/issues/7230
https://projects.theforeman.org/issues/12873
https://projects.theforeman.org/issues/13039
https://github.com/rubiety/validates_lengths_from_database/pull/12

#1 - 01/27/2016 09:49 AM - Dominic Cleal
- Related to Feature #7230: Upgrade Ruby on Rails to 4.1 added

#2 - 01/27/2016 09:49 AM - Dominic Cleal

- Related to Refactor #13039: Remove DB queries from class of UnattendedController added

#3 - 01/27/2016 09:49 AM - Dominic Cleal
- Related to Feature #12873: Update Rails to 4.1.latest added

#4 - 02/08/2016 03:34 AM - Dominic Cleal

- Blocked by Bug #13574: Plugins with Setting subclasses raise super: no superclass method “load_defaults' error added

#5 - 02/08/2016 03:34 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#6 - 02/15/2016 06:23 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3182 added

#7 - 02/15/2016 08:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset f20c2a1abb049b57524fd5cd1e0a9177e9b04fad.

#8 - 02/15/2016 08:07 AM - Dominic Cleal

- translation missing: en.field_release set to 71
